(ns com.aurellem.exp.moves
  (:use (com.aurellem.gb gb-driver items util pokemon))
  (:import [com.aurellem.gb.gb_driver SaveState]))

(defn move-state []
  (read-state "view-pika-attacks"))

(defn view-move [n]
  (run-moves
   (set-memory (move-state) 0xD19E n)
   (concat [[:a]]
           (repeat 200 [])
           [[:a]]
            (repeat 200 []))))

(defn iterate-moves []
  (dorun 
   (map (fn [n] (println n)
          (view-move n)
          (Thread/sleep 5000))
        (range (inc 0xFF)))))

(def moves-codes-pokemon-1 0xD172)

(defn moves-codes-start [pokemon-num]
  (assert (<= 0 pokemon-num 5))
  (+ moves-codes-pokemon-1
     (* pokemon-num pokemon-record-width)))
  

;; 000 00 :  null
;; 001 01 :  pound
;; 002 02 :  karate-chop
;; 003 03 :  doubleslap
;; 004 04 :  comet-punch
;; 005 05 :  mega-punch
;; 006 06 :  pay-day
;; 007 07 :  fire-punch
;; 008 08 :  ice-punch
;; 009 09 :  thunderpunch
;; 010 0A :  scratch
;; 011 0B :  vicegrip
;; 012 0C :  guillotine
;; 013 0D :  razor-wind
;; 014 0E :  swords-dance
;; 015 0F :  cut
;; 016 10 :  gust
;; 017 11 :  wing-attack
;; 018 12 :  whirlwind
;; 019 13 :  fly
;; 020 14 :  bind
;; 021 15 :  slam
;; 022 16 :  vine-whip
;; 023 17 :  stomp
;; 024 18 :  double-kick
;; 025 19 :  mega-kick
;; 026 1A :  jump-kick
;; 027 1B :  rolling-kick
;; 028 1C :  sand-attack
;; 029 1D :  headbutt
;; 030 1E :  horn-attack
;; 031 1F :  fury-attack
;; 032 20 :  horn-drill
;; 033 21 :  tackle
;; 034 22 :  body-slam
;; 035 23 :  wrap
;; 036 24 :  take-down
;; 037 25 :  thrash
;; 038 26 :  double-edge
;; 039 27 :  tail-whip
;; 040 28 :  poison-sting
;; 041 29 :  twinneedle
;; 042 2A :  pin-missle
;; 043 2B :  leer
;; 044 2C :  bite
;; 045 2D :  growl
;; 046 2E :  roar
;; 047 2F :  sing
;; 048 30 :  supersonic
;; 049 31 :  sonicboom
;; 050 32 :  disable
;; 051 33 :  acid
;; 052 34 :  ember
;; 053 35 :  flamethrower
;; 054 36 :  mist
;; 055 37 :  water-gun
;; 056 38 :  hydro-pump
;; 057 39 :  surf
;; 058 3A :  ice-beam
;; 059 3B :  blizzard
;; 060 3C :  psybeam
;; 061 3D :  bubblebeam
;; 062 3E :  aurora-beam
;; 063 3F :  hyper-beam
;; 064 40 :  peck
;; 065 41 :  drill-peck
;; 066 42 :  submission
;; 067 43 :  low-kick
;; 068 44 :  counter
;; 069 45 :  seismic-toss
;; 070 46 :  strength
;; 071 47 :  absorb
;; 072 48 :  mega-drain
;; 073 49 :  leech-seed
;; 074 4A :  growth
;; 075 4B :  razor-leaf
;; 076 4C :  solarbeam
;; 077 4D :  poisonpowder
;; 078 4E :  stun-spore
;; 079 4F :  sleep-powder
;; 080 50 :  petal-dance
;; 081 51 :  string-shot
;; 082 52 :  dragon-rage
;; 083 53 :  fire-spin
;; 084 54 :  thundershock
;; 085 55 :  thunderbolt
;; 086 56 :  thunder-wave
;; 087 57 :  thunder
;; 088 58 :  rock-throw
;; 089 59 :  earthquake
;; 090 5A :  fissure
;; 091 5B :  dig
;; 092 5C :  toxic
;; 093 5D :  confusion
;; 094 5E :  psychic
;; 095 5F :  hypnosis
;; 096 60 :  meditate
;; 097 61 :  agility
;; 098 62 :  quick-attack
;; 099 63 :  rage
;; 100 64 :  teleport
;; 101 65 :  night-shade
;; 102 66 :  mimic
;; 103 67 :  screech
;; 104 68 :  double-team
;; 105 69 :  recover
;; 106 6A :  harden
;; 107 6B :  minimize
;; 108 6C :  smokescreen
;; 109 6D :  confuse-ray
;; 110 6E :  withdraw
;; 111 6F :  defense-curl
;; 112 70 :  barrier
;; 113 71 :  light-screen
;; 114 72 :  haze
;; 115 73 :  reflect
;; 116 74 :  focus-energy
;; 117 75 :  bide
;; 118 76 :  metronome
;; 119 77 :  mirror-move
;; 120 78 :  selfdestruct
;; 121 79 :  egg-bomb
;; 122 7A :  lick
;; 123 7B :  smog
;; 124 7C :  sludge
;; 125 7D :  bone-club
;; 126 7E :  fire-blast
;; 127 7F :  waterfall
;; 128 80 :  clamp
;; 129 81 :  swift
;; 130 82 :  skull-bash
;; 131 83 :  spike-cannon
;; 132 84 :  constrict
;; 133 85 :  amnesia
;; 134 86 :  kinesis
;; 135 87 :  softboiled
;; 136 88 :  hi-jump-kick
;; 137 89 :  glare
;; 138 8A :  dream-eater
;; 139 8B :  poison-gas
;; 140 8C :  barrage
;; 141 8D :  leech-life
;; 142 8E :  lovely-kiss
;; 143 8F :  sky-attack
;; 144 90 :  transform
;; 145 91 :  bubble
;; 146 92 :  dizzy-punch
;; 147 93 :  spore
;; 148 94 :  flash
;; 149 95 :  psywave
;; 150 96 :  splash
;; 151 97 :  acid-armor
;; 152 98 :  crabhammer
;; 153 99 :  explosion
;; 154 9A :  fury-swipes
;; 155 9B :  bonemerang
;; 156 9C :  rest
;; 157 9D :  rock-slide
;; 158 9E :  hyper-fang
;; 159 9F :  sharpen
;; 160 A0 :  conversion
;; 161 A1 :  tri-attack
;; 162 A2 :  super-fang
;; 163 A3 :  slash
;; 164 A4 :  substitute
;; 165 A5 :  struggle
;; 166 A6 :  null
;; 167 A7 :  null
;; 168 A8 :  null
;; 169 A9 :  trash
;; 170 AA :  trash
;; 171 AB :  trash
;; 172 AC :  trash
;; 173 AD :  trash
;; 174 AE :  trash
;; 175 AF :  null
;; 176 B0 :  trash
;; 177 B1 :  trash
;; 178 B2 :  trash
;; 179 B3 :  trash
;; 180 B4 :  AA
;; 181 B5 :  trash
;; 182 B6 :  QQ
;; 183 B7 :  null
;; 184 B8 :  null
;; 185 B9 :  null
;; 186 BA :  null
;; 187 BB :  null
;; 188 BC :  null
;; 189 BD :  null
;; 190 BE :  trash
;; 191 BF :  null
;; 192 C0 :  null
;; 193 C1 :  null
;; 194 C2 :  null
;; 195 C3 :  null
;; 196 C4 :  HM01
;; 197 C5 :  HM02
;; 198 C6 :  HM03
;; 199 C7 :  HM04
;; 200 C8 :  HM05
;; 201 C9 :  TM01
;; 202 CA :  TM02
;; 203 CB :  TM03
;; 204 CC :  TM04
;; 205 CD :  TM05
;; 206 CE :  TM06
;; 207 CF :  TM07
;; 208 D0 :  TM08
;; 209 D1 :  TM09
;; 210 D2 :  TM10
;; 211 D3 :  TM11
;; 212 D4 :  TM12
;; 213 D5 :  TM13
;; 214 D6 :  TM14
;; 215 D7 :  TM15
;; 216 D8 :  TM16
;; 217 D9 :  TM17
;; 218 DA :  TM18
;; 219 DB :  TM19
;; 220 DC :  TM20
;; 221 DD :  TM21
;; 222 DE :  TM22
;; 223 DF :  TM23
;; 224 E0 :  TM24
;; 225 E1 :  TM25
;; 226 E2 :  TM26
;; 227 E3 :  TM27
;; 228 E4 :  TM28
;; 229 E5 :  TM29
;; 230 E6 :  TM30
;; 231 E7 :  TM31
;; 232 E8 :  TM32
;; 233 E9 :  TM33
;; 234 EA :  TM34
;; 235 EB :  TM35
;; 236 EC :  TM36
;; 237 ED :  TM37
;; 238 EE :  TM38
;; 239 EF :  TM39
;; 240 F0 :  TM40
;; 241 F1 :  TM41
;; 242 F2 :  TM42
;; 243 F3 :  TM43
;; 244 F4 :  TM44
;; 245 F5 :  TM45
;; 246 F6 :  TM46
;; 247 F7 :  TM47
;; 248 F8 :  TM48
;; 249 F9 :  TM49
;; 250 FA :  TM50
;; 251 FB :  TM51
;; 252 FC :  TM52
;; 253 FD :  TM53
;; 254 FE :  TM54
;; 255 FF :  TM55


(def move-code->move-name
  {
   0x01   :pound
   0x02   :karate-chop
   0x03   :doubleslap
   0x04   :comet-punch
   0x05   :mega-punch
   0x06   :pay-day
   0x07   :fire-punch
   0x08   :ice-punch
   0x09   :thunderpunch
   0x0A   :scratch
   0x0B   :vicegrip
   0x0C   :guillotine
   0x0D   :razor-wind
   0x0E   :swords-dance
   0x0F   :cut
   0x10   :gust
   0x11   :wing-attack
   0x12   :whirlwind
   0x13   :fly
   0x14   :bind
   0x15   :slam
   0x16   :vine-whip
   0x17   :stomp
   0x18   :double-kick
   0x19   :mega-kick
   0x1A   :jump-kick
   0x1B   :rolling-kick
   0x1C   :sand-attack
   0x1D   :headbutt
   0x1E   :horn-attack
   0x1F   :fury-attack
   0x20   :horn-drill
   0x21   :tackle
   0x22   :body-slam
   0x23   :wrap
   0x24   :take-down
   0x25   :thrash
   0x26   :double-edge
   0x27   :tail-whip
   0x28   :poison-sting
   0x29   :twinneedle
   0x2A   :pin-missle
   0x2B   :leer
   0x2C   :bite
   0x2D   :growl
   0x2E   :roar
   0x2F   :sing
   0x30   :supersonic
   0x31   :sonicboom
   0x32   :disable
   0x33   :acid
   0x34   :ember
   0x35   :flamethrower
   0x36   :mist
   0x37   :water-gun
   0x38   :hydro-pump
   0x39   :surf
   0x3A   :ice-beam
   0x3B   :blizzard
   0x3C   :psybeam
   0x3D   :bubblebeam
   0x3E   :aurora-beam
   0x3F   :hyper-beam
   0x40   :peck
   0x41   :drill-peck
   0x42   :submission
   0x43   :low-kick
   0x44   :counter
   0x45   :seismic-toss
   0x46   :strength
   0x47   :absorb
   0x48   :mega-drain
   0x49   :leech-seed
   0x4A   :growth
   0x4B   :razor-leaf
   0x4C   :solarbeam
   0x4D   :poisonpowder
   0x4E   :stun-spore
   0x4F   :sleep-powder
   0x50   :petal-dance
   0x51   :string-shot
   0x52   :dragon-rage
   0x53   :fire-spin
   0x54   :thundershock
   0x55   :thunderbolt
   0x56   :thunder-wave
   0x57   :thunder
   0x58   :rock-throw
   0x59   :earthquake
   0x5A   :fissure
   0x5B   :dig
   0x5C   :toxic
   0x5D   :confusion
   0x5E   :psychic
   0x5F   :hypnosis
   0x60   :meditate
   0x61   :agility
   0x62   :quick-attack
   0x63   :rage
   0x64   :teleport
   0x65   :night-shade
   0x66   :mimic
   0x67   :screech
   0x68   :double-team
   0x69   :recover
   0x6A   :harden
   0x6B   :minimize
   0x6C   :smokescreen
   0x6D   :confuse-ray
   0x6E   :withdraw
   0x6F   :defense-curl
   0x70   :barrier
   0x71   :light-screen
   0x72   :haze
   0x73   :reflect
   0x74   :focus-energy
   0x75   :bide
   0x76   :metronome
   0x77   :mirror-move
   0x78   :selfdestruct
   0x79   :egg-bomb
   0x7A   :lick
   0x7B   :smog
   0x7C   :sludge
   0x7D   :bone-club
   0x7E   :fire-blast
   0x7F   :waterfall
   0x80   :clamp
   0x81   :swift
   0x82   :skull-bash
   0x83   :spike-cannon
   0x84   :constrict
   0x85   :amnesia
   0x86   :kinesis
   0x87   :softboiled
   0x88   :hi-jump-kick
   0x89   :glare
   0x8A   :dream-eater
   0x8B   :poison-gas
   0x8C   :barrage
   0x8D   :leech-life
   0x8E   :lovely-kiss
   0x8F   :sky-attack
   0x90   :transform
   0x91   :bubble
   0x92   :dizzy-punch
   0x93   :spore
   0x94   :flash
   0x95   :psywave
   0x96   :splash
   0x97   :acid-armor
   0x98   :crabhammer
   0x99   :explosion
   0x9A   :fury-swipes
   0x9B   :bonemerang
   0x9C   :rest
   0x9D   :rock-slide
   0x9E   :hyper-fang
   0x9F   :sharpen
   0xA0   :conversion
   0xA1   :tri-attack
   0xA2   :super-fang
   0xA3   :slash
   0xA4   :substitute
   0xA5   :struggle})

(def move-name->move-code
  (zipmap (vals move-code->move-name)
          (keys move-code->move-name)))

(defn give-moves
  ([^SaveState state pokemon-num moves]
     (set-memory-range
      state
      (moves-codes-start pokemon-num)
      (map #(move-name->move-code % %) moves)))
  ([pokemon-num moves]
     (give-moves @current-state pokemon-num moves))
  ([moves]
     (give-moves 0 moves)))

;; Note regarding PP of moves -- both the current PP and the
;; total PP are stored in the same value.
;; they are bit-packed, with the first 2 bits containing the
;; number of pp-ups that have been applied, and the next
;; six bits containing the current pp of the move.
;; thus, a move can have up to 63 current pp and up to
;; three pp-ups applied.


(def pokemon-1-pp-start 0xD187)

(defn moves-pp-start [pokemon-num]
  (assert (<= 0 pokemon-num 5))
  (+ pokemon-1-pp-start (* pokemon-num pokemon-record-width)))

(defn read-pp
  ([^SaveState state pokemon-num move-num]
     (assert (<= 0 move-num 3))
     (assert (<= 0 pokemon-num 5))
     (let [pp-raw
           (aget (memory state)
                 (+ (moves-pp-start pokemon-num)
                    move-num))
           pp-up
           (bit-shift-right
            (bit-and
             pp-raw
             (Integer/parseInt "11000000" 2)) 6)
           current-pp
           (bit-and
            pp-raw
            (Integer/parseInt "00111111" 2))]
       [pp-up current-pp]))
  ([pokemon-num move-num]
     (read-pp @current-state pokemon-num move-num)))

(defn give-pp
  ([^SaveState state pokemon-num move-num pp-ups current-pp]
     (assert (<= 0 move-num 3))
     (assert (<= 0 pokemon-num 5))
     (assert (<= 0 pp-ups 3))
     (assert (<= 0 current-pp 63))

     (set-memory
      state
      (+ (moves-pp-start pokemon-num)
         move-num)
      (+
       (bit-shift-left pp-ups 6)
       (bit-and (Integer/parseInt
                 "00111111" 2)
                current-pp))))
  ([pokemon-num move-num pp-ups current-pp]
     (set-pp @current-state
             pokemon-num move-num pp-ups current-pp)))
